# DGS4

from math import *
from SWGui import *
initSWGui()

buttonFrame=SWFrameHori() # Ein Container fuer die Buttons
bZug=SWButton(container=buttonFrame,text="Zugmodus")
bPunkt=SWButton(container=buttonFrame,text="Punkt")
bPunktAuf=SWButton(container=buttonFrame,text="Punkt auf")
bMP=SWButton(container=buttonFrame,text="MP")
bSchnitt=SWButton(container=buttonFrame,text="Schnittpunkt")
bGerade=SWButton(container=buttonFrame,text="Gerade")
bLot=SWButton(container=buttonFrame,text="Lot")
bParallele=SWButton(container=buttonFrame,text="Parallele")
bKreis=SWButton(container=buttonFrame,text="Kreis")
bLoesch=SWButton(container=buttonFrame,text="Loeschen")
message=SWLabel(container=buttonFrame,text="")
message.setWidth(22)

zeichenflaeche=SWCanvas(width=400,height=400)

modus="Punkt"   # Jeweils aktueller Modus des Programms
operanden=[]    # Liste von Operanden der aktuellen Operation

def setMode(m,hilfetext):
    global modus,message,operanden 
    modus=m
    message.setText(hilfetext)
    operanden=[]
    
def zugModus(): setMode("Zug","Zugmodus")
def punktModus():setMode("Punkt","Punkt erzeugen")
def punktAufModus():setMode("PunktAuf","Gleiter erzeugen")
def MPModus(): setMode("MP","Mittelpunkt")
def schnittModus(): setMode("Schnitt","Schnittpunkt")
def geradeModus(): setMode("Gerade","Gerade")
def lotModus(): setMode("Lot","Lot")
def paralleleModus(): setMode("Parallele","Parallele")
def kreisModus(): setMode("Kreis","Kreis")
def loeschModus(): setMode("Loeschen","Loeschen")
bZug.setCommand(zugModus)  # Buttons mit Funktion versehen
bPunkt.setCommand(punktModus)
bPunktAuf.setCommand(punktAufModus)
bMP.setCommand(MPModus)
bSchnitt.setCommand(schnittModus)
bGerade.setCommand(geradeModus)
bLot.setCommand(lotModus)
bParallele.setCommand(paralleleModus)
bKreis.setCommand(kreisModus)
bLoesch.setCommand(loeschModus)

# Hilfsfunktionen, die zwischen mathematischen Koordinaten
# und Bildschirm-Koordinaten umrechnen

ausschnitt={"xmin":-10.0,"xmax":10.0,"ymin":-10.0,"ymax":10.0}

def diag(): # Schirmdiagonale
    global ausschnitt
    return sqrt((ausschnitt["xmax"]-ausschnitt["xmin"])**2+
              (ausschnitt["xmax"]-ausschnitt["xmin"])**2)

def welt2schirm(co):
    global ausschnitt,zeichenflaeche
    a=ausschnitt
    [xw,yw]=co
    [w,h]=zeichenflaeche.getDim()
    sc=[w*(xw-a["xmin"])/(a["xmax"]-a["xmin"]),
        h*(1-(yw-a["ymin"])/(a["ymax"]-a["ymin"]))]
    return map(int,sc)

def schirm2welt(co):
    global ausschnitt,zeichenflaeche
    a=ausschnitt
    [xs,ys]=co
    [w,h]=zeichenflaeche.getDim()
    return [a["xmin"]+(a["xmax"]-a["xmin"])*xs/float(w),
            a["ymin"]+(a["ymax"]-a["ymin"])*(1-ys/float(h))]

lastClick=[0.0,0.0]

def klick(event):
    global modus,operanden,lastClick
    co=schirm2welt([event.x,event.y])
    lastClick=co
    if modus=="Punkt": erzeugePunkt(co)
    else:
        obj=getroffen(co)
        if obj==None: return
        print "Klick trifft: ", obj["name"]
        operanden.append(obj)
        if modus=="PunktAuf" and len(operanden)==1:
            erzeugePunktAuf(operanden)
            operanden=[]
        if modus=="MP" and len(operanden)==2:
            erzeugeMittelpunkt(operanden)
            operanden=[]
        if modus=="Schnitt" and len(operanden)==2:
            erzeugeSchnittpunkt(operanden)
            operanden=[]
        if modus=="Kreis" and len(operanden)==2:
            erzeugeKreis(operanden)
            operanden=[]
        if modus=="Gerade" and len(operanden)==2:
            erzeugeGerade2P(operanden)
            operanden=[]
        if modus=="Lot" and len(operanden)==2:
            erzeugeLot(operanden)
            operanden=[]
        if modus=="Parallele" and len(operanden)==2:
            erzeugeParallele(operanden)
            operanden=[]
        if modus=="Loeschen" and len(operanden)==1:
            loesche(operanden)
            operanden=[]

def drag(event):
    co=schirm2welt([event.x,event.y])
    if modus=="Zug":
        if len(operanden)==0: return # Kein Objekt ausgewaehlt
        call(operanden[-1],"moveTo",co) # Das zu letzt bewegte Objekt wird bewegt

def loslassen(event):
    global modus,operanden
    if modus=="Zug": operanden=[]

zeichenflaeche.setClickCommand(klick)
zeichenflaeche.setReleaseCommand(loslassen)
zeichenflaeche.setDragCommand(drag)

# --- Routinen zur Behandlung der geometrischen Objekte

objekte=[] # Liste aller Objekte

def getroffen(co): # Gibt None oder Objekt, das nahe bei co liegt
    global objekte
    treffer=[]
    for a in objekte:
        if call(a,"getroffen",co): treffer.append(a)
    if treffer==[]: return None
    if len(treffer)==1: return treffer[0]
    liste=[ob["name"] for ob in treffer]
    name=SWListChoiceDialog(liste)
    for obj in treffer:
        if obj["name"]==name:
            return obj
    return None

def loesche(ops):
    global objekte
    print "Loesche", ops[0]["name"]
    global zeichenflaeche,objekte
    for e in ops[0]["eltern"]:
        e["kinder"].remove(ops[0])
    if ops[0]["kinder"]<>[]:
        for o in ops[0]["kinder"]: loesche([o])
    zeichenflaeche.delete(ops[0]["gui"])
    objekte.remove(ops[0]) 

Pzaehler,Gzaehler,Kzaehler=0,0,0
def punktName():
    global Pzaehler
    Pzaehler=Pzaehler+1
    return "P"+str(Pzaehler)
def geradeName():
    global Gzaehler
    Gzaehler=Gzaehler+1
    return "G"+str(Gzaehler)
def kreisName():
    global Kzaehler
    Kzaehler=Kzaehler+1
    return "K"+str(Kzaehler)

# Jetzt kommt ein ad hoc Klassensystem mit Vererbung
# Objekte sind Dictionaries, mit einer Methodentabelle

def call(obj,methname,*args): # Methodenaufruf
    alleArgs=[obj]+list(args)           # Das ist Liste [obj,arg1,arg2,..]
    methode=obj["methoden"][methname]   # Das ist die Methoden-Funktion
    return apply(methode, alleArgs)

def istGerade(A):
    if A["Klasse"]=="Gerade": return True
    return A["Oberklasse"]=="Gerade"

def istPunkt(A):
    if A["Klasse"]=="Punkt": return True
    return A["Oberklasse"]=="Punkt"

def istKreis(A): return A["Klasse"]=="Kreis"

def erzeugeGeoObj(): # Allgemeines Geo.Objekt
    global objekte
    P={"name":"?"}
    # P ist Dictionary mit allen Informationen 
    P["gui"]=None
    P["label"]=zeichenflaeche.createText(-10,-10,P["name"])
    P["Klasse"]="GeoObj"
    P["Oberklasse"]=""
    P["frei"]=False # Ist das Objekt ziehbar?
    P["kinder"]=[]
    P["eltern"]=[]
    def update0(mich):
        pass # Dummy-Methode: Sich selbst aktualisieren
    def update(mich):
        call(mich,"update0")
        for kind in mich["kinder"]: call(kind,"update")
    def moveTo(ich,co):
        pass
    P["methoden"]={"update":update,"update0":update0,"moveTo":moveTo}
    objekte.append(P)
    return P

def erzeugePunkt(co): # Co ist Liste von Weltkoordinaten
    global zeichenflaeche,objekte
    P=erzeugeGeoObj()
    P["Klasse"]="Punkt"
    P["Oberklasse"]="GeoObj"
    P["name"]=punktName()
    P["frei"]=True # Ist das Objekt ziehbar?
    [P["x"],P["y"]]=co
    P["gui"]=zeichenflaeche.createCircle(-10,-10,5)
    P["gui"].setColor("red")
    def update0(mich):
        [sx,sy]=welt2schirm([mich["x"],mich["y"]])
        mich["gui"].setCenter(sx,sy)
        mich["label"].setCoords([sx+15,sy])
        mich["label"].setText(mich["name"])
    update0(P)
    P["methoden"]["update0"]=update0
    def getroffen(ich,co):
        return sqrt((co[0]-ich["x"])**2+(co[1]-ich["y"])**2)<diag()/100.0
    P["methoden"]["getroffen"]=getroffen
    def moveTo(ich,co):
        if ich["frei"]:
            [ich["x"],ich["y"]]=co
            call(ich,"update")
    P["methoden"]["moveTo"]=moveTo            
    return P
    
def erzeugeMittelpunkt(ops):
    global zeichenflaeche,objekte
    [A,B]=ops
    P=erzeugePunkt([1.0,2.0]) # Koordinaten erstmal unwichtig
    P["Klasse"]="Mittelpunkt"
    P["Oberklasse"]="Punkt"
    A["kinder"].append(P)
    B["kinder"].append(P)
    P["eltern"]=ops
    P["frei"]=False
    P["gui"].setColor("blue")
    def update0(mich):
        A=mich["eltern"][0]
        B=mich["eltern"][1]
        co=[ (A["x"]+B["x"])/2.0, (A["y"]+B["y"])/2.0 ]
        [mich["x"],mich["y"]]=co 
        [sx,sy]=welt2schirm([mich["x"],mich["y"]])
        mich["gui"].setCenter(sx,sy)
        mich["label"].setCoords([sx+15,sy])
        mich["label"].setText(mich["name"])
    update0(P)
    P["methoden"]["update0"]=update0
    return P

def erzeugePunktAuf(ops):
    global zeichenflaeche,objekte,lastClick
    if not(istKreis(ops[0]) or istGerade(ops[0])): return None
    P=erzeugePunkt(lastClick) # Koordinaten erstmal unwichtig
    P["Klasse"]="Gleiter"
    P["Oberklasse"]="Punkt"
    ops[0]["kinder"].append(P)
    P["eltern"]=ops
    P["frei"]=True
    P["gui"].setColor("blue")
    def moveTo(ich,co):
        f=None
        traeger=ich["eltern"][0]
        if istGerade(traeger):
            f=lambda x,y: (x*traeger["a"]+y*traeger["b"]-traeger["c"])**2
        if istKreis(traeger):
            f=lambda x,y: ((x-traeger["x"])**2+(y-traeger["y"])**2-traeger["r"]**2)**2
        co=minimiere2(f,ich["x"],ich["y"])
        if co==[]: return
        [ich["x"],ich["y"]]=co
        for kind in ich["kinder"]: call(kind,"update")
    P["methoden"]["moveTo"]=moveTo
    def update0(mich):
        f=None
        traeger=mich["eltern"][0]
        if istGerade(traeger):
            f=lambda x,y: (x*traeger["a"]+y*traeger["b"]-traeger["c"])**2
        if istKreis(traeger):
            f=lambda x,y: ((x-traeger["x"])**2+(y-traeger["y"])**2-traeger["r"]**2)**2
        if f==None: return
        co=minimiere2(f,mich["x"],mich["y"])
        if co==[]: return
        [mich["x"],mich["y"]]=co
        [sx,sy]=welt2schirm(co)
        mich["gui"].setCenter(sx,sy)
        mich["label"].setCoords([sx+15,sy])
        mich["label"].setText(mich["name"])
    update0(P)
    P["methoden"]["update0"]=update0
    return P

def erzeugeSchnittpunkt(ops):
    global zeichenflaeche,objekte,lastClick
    [A,B]=ops
    P=erzeugePunkt(lastClick) # Liegt in der Naehe, wied eh noch berechnet
    P["Klasse"]="Schnittpunkt"
    P["Oberklasse"]="Punkt"
    A["kinder"].append(P)
    B["kinder"].append(P)
    P["eltern"]=ops
    P["frei"]=False
    P["gui"].setColor("green")
    def update0(mich):
        A=mich["eltern"][0]
        B=mich["eltern"][1]
        co=[]
        if A["Klasse"]=="Kreis" and B["Klasse"]=="Kreis":
            co=kreisSP([A["x"],A["y"],A["r"]],[B["x"],B["y"],B["r"]],[mich["x"],mich["y"]])
        if istGerade(B) and A["Klasse"]=="Kreis":
            co=kreisGeradeSP([A["x"],A["y"],A["r"]],[B["a"],B["b"],B["c"]],[mich["x"],mich["y"]])
        if istGerade(A) and B["Klasse"]=="Kreis":
            co=kreisGeradeSP([B["x"],B["y"],B["r"]],[A["a"],A["b"],A["c"]],[mich["x"],mich["y"]])
        if istGerade(A) and istGerade(B):
            co=geradenSP([B["a"],B["b"],B["c"]],[A["a"],A["b"],A["c"]],[mich["x"],mich["y"]])
        if co==[]: return # Konnte nicht berechnet werden
        [mich["x"],mich["y"]]=co 
        [sx,sy]=welt2schirm([mich["x"],mich["y"]])
        mich["gui"].setCenter(sx,sy)
        mich["label"].setCoords([sx+15,sy])
        mich["label"].setText(mich["name"])
    update0(P)
    P["methoden"]["update0"]=update0
    return P

def erzeugeKreis(MP): # MP ist Liste aus Mittelpunkt und Randpunkt
    global zeichenflaeche,objekte
    K=erzeugeGeoObj()
    K["Klasse"]="Kreis"
    K["Oberklasse"]="GeoObj"
    K["name"]=kreisName()
    K["eltern"]=MP
    [M,Q]=MP
    M["kinder"].append(K)
    Q["kinder"].append(K)
    [K["x"],K["y"],K["r"]]=[0,0,0] # Dummy-Wert, wird noch berechnet
    K["gui"]=zeichenflaeche.createCircle(-10,-10,5)
    K["gui"].setColor("") # Keine Fuellfarbe
    def update0(mich):
        mich["x"]=mich["eltern"][0]["x"]
        mich["y"]=mich["eltern"][0]["y"]
        mich["r"]=sqrt((mich["x"]-mich["eltern"][1]["x"])**2+(mich["y"]-mich["eltern"][1]["y"])**2)
        [x2,y2]=[mich["eltern"][1]["x"],mich["eltern"][1]["y"]]
        [sx,sy]=welt2schirm([mich["x"],mich["y"]])
        [sx2,sy2]=welt2schirm([x2,y2])
        sr=int(sqrt((sx-sx2)**2+(sy-sy2)**2))
        mich["gui"].setCenter(sx,sy)
        mich["gui"].setRadius(sr)
        mich["label"].setCoords([sx+15+sr,sy])
        mich["label"].setText(mich["name"])
    update0(K)
    K["methoden"]["update0"]=update0
    def getroffen(ich,co):
        R=sqrt((co[0]-ich["x"])**2+(co[1]-ich["y"])**2) # Abstand MP-Klick
        return abs(R-ich["r"])<diag()/50.0
    K["methoden"]["getroffen"]=getroffen
    return K

def erzeugeGerade(): 
    global zeichenflaeche,objekte
    G=erzeugeGeoObj()
    G["Klasse"]="Gerade"
    G["Oberklasse"]="GeoObj"
    G["name"]=geradeName()
    [G["a"],G["b"],G["c"]]=[1,1,1]
    G["gui"]=zeichenflaeche.createLine(-10,-10,-11,-11)
    G["gui"].setColor("black")
    def update0(mich):
        pass
    G["methoden"]["update0"]=update0
    def getroffen(ich,co):
        [a,b,c]=[ich["a"],ich["b"],ich["c"]]
        n=sqrt(a*a+b*b)
        [a,b,c]=[a/n,b/n,c/n] # Hesse-Normalform
        d=abs(a*co[0]+b*co[1]-c)
        return d<diag()/100.0
    G["methoden"]["getroffen"]=getroffen
    return G

def erzeugeGerade2P(ops):
    global zeichenflaeche,objekte
    print "Erzeuge Gerade2P"
    [A,B]=ops
    G=erzeugeGerade() 
    G["Klasse"]="Gerade2P"
    G["Oberklasse"]="Gerade"
    A["kinder"].append(G)
    B["kinder"].append(G)
    G["eltern"]=ops
    def update0(mich):
        A=mich["eltern"][0]
        B=mich["eltern"][1]
        [x1,y1]=[A["x"],A["y"]]
        [x2,y2]=[B["x"],B["y"]]
        [a,b]=[y2-y1,x1-x2]
        c=a*x1+b*y1
        [mich["a"],mich["b"],mich["c"]]=[a,b,c]
        [sx1,sy1]=welt2schirm([x1-30*(x2-x1),y1-30*(y2-y1)])
        [sx2,sy2]=welt2schirm([x1+30*(x2-x1),y1+30*(y2-y1)])
        mich["gui"].setCoords([sx1,sy1,sx2,sy2])
        [sx,sy]=welt2schirm([(x1+x2)/2.0,(y1+y2)/2.0])
        mich["label"].setCoords([sx+10,sy])
        mich["label"].setText(mich["name"])
    update0(G)
    G["methoden"]["update0"]=update0
    return G

def erzeugeLot(ops):
    global zeichenflaeche,objekte
    if istPunkt(ops[0]): [P,h]=ops
    else: [h,P]=ops
    G=erzeugeGerade() 
    G["Klasse"]="Lot"
    G["Oberklasse"]="Gerade"
    h["kinder"].append(G)
    P["kinder"].append(G)
    G["eltern"]=[h,P]
    def update0(mich):
        h=mich["eltern"][0]
        P=mich["eltern"][1]
        [mich["a"],mich["b"]]=[h["b"],-h["a"]]
        mich["c"]=mich["a"]*P["x"]+mich["b"]*P["y"]
        [sx1,sy1]=welt2schirm([P["x"]+30*h["a"],P["y"]+30*h["b"]])
        [sx2,sy2]=welt2schirm([P["x"]-30*h["a"],P["y"]-30*h["b"]])
        mich["gui"].setCoords([sx1,sy1,sx2,sy2])
    update0(G)
    G["methoden"]["update0"]=update0
    return G

def erzeugeParallele(ops):
    global zeichenflaeche,objekte
    if istPunkt(ops[0]): [P,h]=ops
    else: [h,P]=ops
    G=erzeugeGerade() 
    G["Klasse"]="Parallele"
    G["Oberklasse"]="Gerade"
    h["kinder"].append(G)
    P["kinder"].append(G)
    G["eltern"]=[h,P]
    def update0(mich):
        h=mich["eltern"][0]
        P=mich["eltern"][1]
        [mich["a"],mich["b"]]=[h["a"],h["b"]]
        mich["c"]=mich["a"]*P["x"]+mich["b"]*P["y"]
        [sx1,sy1]=welt2schirm([P["x"]+30*h["b"],P["y"]-30*h["a"]])
        [sx2,sy2]=welt2schirm([P["x"]-30*h["b"],P["y"]+30*h["a"]])
        mich["gui"].setCoords([sx1,sy1,sx2,sy2])
    update0(G)
    G["methoden"]["update0"]=update0
    return G



# Ein paar Mathematische Helferlein

def abstand(A,B): return sqrt((A[0]-B[0])**2+(A[0]-B[0])**2)

def kreisSP(K1,K2,p0): # Schnittpunkte zweier Kreise berechnen
    # Berechnung geht nummerisch, p0 ist startwert (Liste von 2 Zahlen)
    [x1,y1,r1]=K1
    [x2,y2,r2]=K2
    f=lambda x,y: ((x-x1)**2+(y-y1)**2-r1**2)**2+((x-x2)**2+(y-y2)**2-r2**2)**2
    return minimiere2(f,p0[0],p0[1])
def kreisGeradeSP(K,G,p0): # Schnittpunkte Kreis,Gerade berechnen
    [x1,y1,r1]=K
    [a,b,c]=G
    f=lambda x,y: ((x-x1)**2+(y-y1)**2-r1**2)**2+(a*x+b*y-c)**2
    return minimiere2(f,p0[0],p0[1])
def geradenSP(G1,G2,p0): # Schnittpunkte Gerade,Gerade berechnen
    [a1,b1,c1]=G1
    [a2,b2,c2]=G2
    f=lambda x,y: (a1*x+b1*y-c1)**2+(a2*x+b2*y-c2)**2
    return minimiere2(f,p0[0],p0[1])

def minimiere2(f,x,y): # Nummerisches Minimum eine Funktion in zwei Vars
    d=0.00001
    h=0.000001
    step=0.005
    counter=10000
    while counter>0:
        counter=counter-1
        grad=[(f(x+h,y)-f(x,y))/h,(f(x,y+h)-f(x,y))/h]
        if abstand(grad,[0,0])<d: return [x,y]
        x=x-grad[0]*step
        y=y-grad[1]*step
    return []


