# Objektorientierung mit Tabellen mit Methoden in Klassen

from math import *

# Eine Klasse Punkt wird ber ihren Konstruktor mkPunkt definiert:

MethodenTabellefuerKlasse={} # Hier werden alle Methodentabellen gespeichert

def mkPunkt(name,x,y):
    global MethodenTabellefuerKlasse
    punkt={"x":x, "y":y, "name":name, "Klasse":"Punkt"}
    def setzeName(ich,neu):
        ich["name"]=neu
    def betrag(ich): return sqrt(ich["x"]**2+ich["y"]**2)
    def nachRechts(ich,dx):
        ich["x"]=ich["x"]+dx
    def beschreibe(mich):
        return mich["Klasse"]+":"+mich["name"]+", x="+str(mich["x"])+", y="+str(mich["y"])
    methoden={"setzeName":setzeName, "betrag":betrag, "nachRechts":nachRechts,
              "beschreibe":beschreibe}
    MethodenTabellefuerKlasse["Punkt"]=methoden
    return punkt

def call(obj,methname,*args):
    global MethodenTabellefuerKlasse
    alleArgs=[obj]+list(args)       # Das ist Liste [objekt,arg1,arg2,..]
    KlassenName=obj["Klasse"]       # Name der Klasse des Objekts
    MethTab=MethodenTabellefuerKlasse[KlassenName] # Methodentabelle der Klasse
    methode=MethTab[methname]       # Das ist die Methoden-Funktion
    return apply(methode, alleArgs)

p1=mkPunkt("P1",5,6)
p2=mkPunkt("P2",5,9)
print call(p1,"beschreibe")
print call(p2,"beschreibe")
call(p1,"nachRechts",50)
print call(p1,"beschreibe")
call(p1,"setzeName","P1neu")
print call(p1,"beschreibe")
print call(p2,"beschreibe")


# Jetzt wird eine Klasse abgeleitet

def mkMittelPunkt(name,P,Q): # P Q sind Punkte
    global MethodenTabellefuerKlasse
    punkt=mkPunkt(name,0,0) # Erst mal mit falschen Koordinaten erzeugen - Von Punkt erben
    punkt["Klasse"]="MittelPunkt"
    punkt["P"]=P            # Neue Attribute
    punkt["Q"]=Q
    def berechne(mich):     # Neue Methoden
        mich["x"]=(P["x"]+Q["x"])/2.0
        mich["y"]=(P["y"]+Q["y"])/2.0
    berechne(punkt)
    MethodenTabellefuerKlasse["MittelPunkt"]=MethodenTabellefuerKlasse["Punkt"]
    MethodenTabellefuerKlasse["MittelPunkt"]["berechne"]=berechne
    return punkt


M=mkMittelPunkt("M1",p1,p2)
print call(M,"beschreibe")
call(p1,"nachRechts",50)
call(M,"berechne")
print "Jetzt wurde um 50 nach rechts bewegt"
print call(p1,"beschreibe")
print call(p2,"beschreibe")
print call(M,"beschreibe")
        

